/* Copyright (C) 2023 FIAS Frankfurt Institute for Advanced Studies, Frankfurt / Main
   SPDX-License-Identifier: GPL-3.0-only
   Authors: Felix Weiglhofer [committer] */
#include "UnpackChain.h"

using namespace cbm::algo;

void UnpackChain::Init()
{
  bool ok = fUnpack.Init(std::vector<fles::SubsystemIdentifier> {
    fles::SubsystemIdentifier::STS,
    // fles::SubsystemIdentifier::MUCH,
    fles::SubsystemIdentifier::RPC, fles::SubsystemIdentifier::T0,
    // fles::SubsystemIdentifier::TRD,
    // fles::SubsystemIdentifier::TRD2D,
  });
  if (!ok) throw std::runtime_error("Unpack::Init failed");
}

Unpack::resultType UnpackChain::Run(const fles::Timeslice& timeslice)
{
  auto result = fUnpack(&timeslice);

  auto& digis = result.first.fData;

  L_(info) << "Timeslice contains " << digis.fSts.Size() << " STS Digis";
  L_(info) << "Timeslice contains " << digis.fTof.Size() << " TOF Digis";
  L_(info) << "Timeslice contains " << digis.fT0.Size() << " T0 Digis";

  return result;
}
